FUNCTION_FIND = {
	if (IS_CWA) then {
		(_this select 1) find (_this select 0)
	} else {
		private ["_i", "_break"];
		_i     = 0;
		_break = false; 

		while "!_break" do {
			if (_i >= count (_this select 1)) then {
				_i     = -1; 
				_break = true
			} else {
				if ((_this select 0) == (_this select 1) select _i) then {
					_break = true
				} else {
					_i = _i + 1
				}
			}
		};

		_i
	}
};

FUNCTION_FORMAT_SECONDS = {
	private ["_minutes", "_seconds", "_return"];
	
	_return = "";
	_this = _this - (_this mod 1);
	
	_minutes = _this / 60;
	_minutes = _minutes - (_minutes mod 1);
	
	if (_minutes > 0) then {
		_return = Format ["%1m", _minutes];
	};
	
	_seconds = _this - (_minutes*60);
	if (_seconds>0 || _this==0) then {
		_space = if (_return != "") then {" "} else {""};
		_return = Format ["%1%2%3s", _return, _space, _seconds]
	};
	
	_return
};

FUNCTION_ERROR = {
	if (!(_ok select 0)) then {
		player sideChat Format ["%1. %2 (%3)", _this, _ok select 3, _ok select 1]; 
		if (DEBUG_LOG) then {loadFile Format ["\:IGSE WRITE file:..\fwatch\idb\FRevive_Automate\log.txt escape:tn text:ERROR: \t\t%1 %2",_this, _ok]};
		goto "SkipMission"
	};
	
	_ok select 0
};

FUNCTION_DEFAULT_VARIABLES = {
	_text_var = [
		"SOURCE_FOLDER",
		"DESTINATION_FOLDER",
		"MARKER_A",
		"MARKER_B",
		"RESPAWN_DELAY",
		"PICKUP_RANGE",
		"PICKUP_TIME",
		"AI_MOVE_RANGE",
		"PARTICLE_SIZE",
		"PARTICLE_LF",
		"MEDICS",
		"LIMIT",
		"TIMEOUT",
		"INTERVAL"
	];
	
	_text_var_description = [
		"Source Folder",
		"Destination Folder",
		"Marker Width",
		"Marker Height",
		"Respawn Delay",
		"Revive Range",
		"Revive Time",
		"AI Move Range",
		"Particle Size",
		"Particle Lifetime",
		"Medic Classes",
		"Revive Limit",
		"Revive Timeout",
		"Script Sleep Time"
	];
	
	_text_idc = [
		10,  //source folder
		20,  //destination folder
		50,  //marker a
		60,  //marker b
		70,  //respawn delay
		90,  //pickup range
		100, //pickup time
		110, //ai move range
		140, //particle size
		150, //particle lifetime
		180, //medic classes
		200, //revive limit
		210, //revive timeout
		220  //interval
	];
	
	_text_var_default = [
		{"example"},                                           //source folder                          
		{"..\fwatch\tmp\FREVIVE_missions"},                    //destination folder
		1,                                                     //marker a
		1,                                                     //marker b
		10,                                                    //respawn delay
		2.5,                                                   //pickup range
		6,                                                     //pickup time
		200,                                                   //ai move range
		{"[1]"},                                               //particle size
		1,                                                     //particle lifetime
		{["SoldierWMedic","SoldierEMedic","SoldierGMedic"]},   //medic classes
		-1,                                                    //revive limit
		-1,                                                    //revive timeout
		0.1                                                    //interval
	];
	
	_text_is_number = [
		false,  //source folder
		false,  //destination folder
		true,   //marker a
		true,   //marker b
		true,   //respawn delay
		true,   //pickup range
		true,   //pickup time
		true,   //ai move range
		false,  //particle size
		true,   //particle lifetime
		false,  //medic classes
		true,   //revive limit
		true,   //revive timeout
		true    //interval
	];
	
	_i = -1;
	while "_i=_i+1; _i < count _text_idc" do {	
		call Format ["FREVIVE_%1=%2", _text_var select _i, _text_var_default select _i];
		ctrlSetText [(_text_idc select _i), _text_var_default select _i];
		ctrlSetText [(_text_idc select _i)+1, _text_var_description select _i];
	};
	
	_list_var = [
		"MARKER_TYPE",
		"MARKER_COLOR",
		"CHANGE_MISSION_NAME",
		"TAKE_GUNS_BEFORE",
		"DROP_PARTICLE",
		"USE_FLAGS",
		"ONLY_MEDIC",
		"SOUND",
		"MSG_STYLE",
		"KILL_CAM"
	];
	
	_list_var_description = [
		"Marker Type",
		"Marker Colour",
		"Mission Name",
		"Retrieve Guns After",
		"Show Particle",
		"Use Flags",
		"Only Medic Revive",
		"Cries for help",
		"Chat Message",
		"Kill Cam"
	];
	
	_list_idc = [
		30,  //marker type
		40,  //marker color
		80,  //change mission name
		120, //take guns before
		130, //show particle
		160, //use flags
		170, //only medic revive
		190, //cries for help
		230, //message style
		240  //kill cam
	];

	_boolean_data  = ["false","true"];
	_boolean_text  = ["No","Yes"];
	
	_list_text = [
		["Flag","Flag1","Dot","Destroy","Start","End","Warning","Join","Pickup","Unknown","Marker","Arrow","Empty"],               //marker type
		["Default","ColorBlack","ColorRed","ColorRedAlpha","ColorGreen","ColorGreenAlpha","ColorBlue","ColorYellow","ColorWhite"], //marker color
		["Add Suffix", "Add Prefix", "No Change"],                                                                                 //change mission name
		["revive","respawn"],                                                                                                      //take guns before
		_boolean_text,                                                                                                             //show particle
		_boolean_text,                                                                                                             //use flags
		_boolean_text,                                                                                                             //only medic revive
		_boolean_text,                                                                                                             //cries for help
		["Global","Side","Disabled"],                                                                                              //message style
		_boolean_text                                                                                                              //kill cam
	];
	
	_list_data = [
		["Flag","Flag1","Dot","Destroy","Start","End","Warning","Join","Pickup","Unknown","Marker","Arrow","Empty"],               //marker type
		["Default","ColorBlack","ColorRed","ColorRedAlpha","ColorGreen","ColorGreenAlpha","ColorBlue","ColorYellow","ColorWhite"], //marker color
		["suffix","prefix","nochange"],                                                                                            //change mission name
		_boolean_data,                                                                                                             //take guns before
		_boolean_data,                                                                                                             //show particle
		_boolean_data,                                                                                                             //use flags
		_boolean_data,                                                                                                             //only medic revive
		_boolean_data,                                                                                                             //cries for help
		["0","2","-1"],                                                                                                            //message style
		_boolean_data                                                                                                              //kill cam
	];
	
	_list_default = [
		0, //marker type
		0, //marker color
		1, //change mission name
		0, //take guns before
		1, //show particle
		0, //use flags
		0, //only medic revive
		0, //cries for help
		0, //message style
		1  //kill cam
	];

	_i = -1;
	while "_i=_i+1; _i < count _list_idc" do {
		call Format ["FREVIVE_%1=""%2""", _list_var select _i, (_list_data select _i) select (_list_default select _i)];
		
		lbClear (_list_idc select _i);
		
		_j = -1;
		while "_j=_j+1; _j < count (_list_text select _i)" do {
			lbSetData [
				(_list_idc select _i), 
				lbAdd [(_list_idc select _i), (_list_text select _i) select _j],
				(_list_data select _i) select _j
			];
		};
		
		lbSetCurSel [_list_idc select _i, _list_default select _i];
		ctrlSetText [(_list_idc select _i)+1, _list_var_description select _i];
	};
};

FUNCTION_REFRESH_DIALOG = {
	_text_state resize 0;
	_i = -1;
	while "_i=_i+1; _i < count _text_idc" do {		
		ctrlSetText [(_text_idc select _i), Format ["%1",call ("FREVIVE_"+(_text_var select _i))]];
		_text_state set [count _text_state, Format ["%1",call ("FREVIVE_"+(_text_var select _i))]];
	};
	
	_list_state resize 0;
	_i = -1;
	while "_i=_i+1; _i < count _list_idc" do {		
		_index = [call ("FREVIVE_"+(_list_var select _i)), _list_data select _i] call FUNCTION_FIND;
		if (_index < 0) then {_index=0};		
		lbSetCurSel [_list_idc select _i, _index];
		_list_state set [count _list_state, _index];
	};
};

FUNCTION_UPDATE_VARIABLES = {
	_i = -1;
	{
		_i = _i + 1;
		if (ctrlText _x != (_text_state select _i)) then {
			if ((_text_is_number select _i)) then {
				if ((loadFile Format ["\:STRING ISNUMBER text:%1", ctrlText _x]) != "string") then {
					call Format ["FREVIVE_%1=%2", _text_var select _i, ctrlText _x];
					_text_state set [_i, ctrlText _x];
				} else {
					ctrlSetText [_x, _text_state select _i]
				}
			} else {
				call Format ["FREVIVE_%1={%2}", _text_var select _i, ctrlText _x];
				_text_state set [_i, ctrlText _x];
			};
		}
	} forEach _text_idc;
	
	_i = -1;
	{
		_i = _i + 1;
		if (lbCurSel _x != (_list_state select _i)) then {
			call Format ["FREVIVE_%1=""%2""", _list_var select _i, lbData [_x, lbCurSel _x]];
			_list_state set [_i, lbCurSel _x];
		}
	} forEach _list_idc;
};

FUNCTION_ADD_OPTIONS_ACTION = {
	FREVIVE_OPTIONS_ACTION = player addAction ["Options","Dialog.sqs"];
};

FUNCTION_CHECK_TITLEPARAM = {
	private ["_i", "_output", "_property_name", "_property_value", "_positions", "_first_character", "_string_name", "_ok", "_igseload", "_text_line", "_tokens"];
	_i = -1;
	
	_output = [
		false, 	// titleparam1 is number of respawns
		false   // is joe revive
	];
	
	while "_i=_i+1; _i < count _properties" do {
		_property_name  = loadFile ("\:STRING CASE lower:1 text:" + (_properties select _i));
		_property_value = loadFile ("\:STRING CASE lower:1 text:" + (_values select _i));
		
		if (_property_name == "titleparam1") then {
			_first_character = loadFile ("\:STRING CUT end:1 text:" + _property_value);

			// If it's a string from a stringtable
			if (_first_character in ["$","@"]) then {
				_string_name = loadFile ("\:STRING CUT start:1 text:" + _property_value);
				_ok          = call loadFile Format ["\:IGSE FIND ""file:%1\%2\stringtable.csv"" ignoreLeadSpace:1 column:0 limit:1 text:%3", _destination_folder, _mission_name, _string_name];
				
				// Load the line from the stringtable
				if (count (_ok select 5) > 0) then {
					_igseload = call loadFile Format ["\:IGSE LOAD ""file:%1\%2\stringtable.csv"" mode:separate start:%3 end:%3", _destination_folder, _mission_name, (_ok select 5) select 0];
					
					if (count ((_igseload select 4) select 0) > 0) then {
						_text_line = ((_igseload select 4) select 0) select 0;						
						_tokens    = call loadFile ("\:STRING TOKENIZE quoteSkip:1 delimiter:,text:" + _text_line);
						
						// Split the line by commas
						if (count _tokens >= 2) then {
							_property_value = loadFile ("\:STRING CASE lower:1 text:" + (_tokens select 1));
						}
					}
				}
			};
			
			_property_value = loadFile ("\:STRING REPLACECHAR text:%1find::replace:" + _property_value);
			
			if (_property_value in ["respawns","respawn","revive","revives","respawn count"]) then {
				_output set [0, true]
			};
		};
		
		if (_property_name == "textsparam1[]") then {
			_positions = call loadFile ("\:STRING FIND find:5 lifestext:" + _property_value);
			if (count _positions > 0) then {
				_output set [1, true]
			}
		};
	};
	
	_output
};

LIST_OF_KNOWN_VEHICLES = [
	"A10",
	"Cobra",
	"UH60",
	"UH60MG",
	"Mi17",
	"Mi24",
	"Cessna",
	"Su25",
	"AH64",
	"CH47D",
	"A10LGB",
	"OH58",
	"Kamov",
	"JetRanger",
	"JetRangerSilent",
	"M1Abrams",
	"M60",
	"M113",
	"BMP",
	"T72",
	"T80",
	"ZSU",
	"T55G",
	"BoatW",
	"BoatE",
	"CarrierW",
	"M2StaticMG",
	"M2StaticMGE",
	"Vulcan",
	"BMP2",
	"Bradley",
	"BRDM",
	"BMPRes",
	"T72Res",
	"T80Res",
	"Jeep",
	"Truck5t",
	"Truck5tRich",
	"Truck5topen",
	"JeepMG",
	"GJeep",
	"UAZ",
	"Ural",
	"UAZG",
	"TruckV3SG",
	"TruckV3SCivil",
	"SkodaBlue",
	"Skoda",
	"SkodaRed",
	"SkodaGreen",
	"RapidY",
	"Rapid",
	"Trabant",
	"HMMWV",
	"JeepPolice",
	"Bus",
	"Jawa",
	"UAZCheat",
	"Mini",
	"Kolo",
	"Tractor",
	"Scud",
	"SGUAZG",
	"TruckV3SGReammo",
	"TruckV3SGRefuel",
	"TruckV3SGRepair",
	"UralReammo",
	"UralRefuel",
	"UralRepair",
	"Truck5tReammo",
	"Truck5tRefuel",
	"Truck5tRepair",
	"M113Ambul",
	"BMPAmbul",
	"BISCamel",
	"BISCamel2",
	"T80Auto",
	"M1AbramsAuto",
	"PaperCar",
	"ParachuteBase",
	"ParachuteEast",
	"ParachuteWest",
	"ParachuteC",
	"ParachuteG",
	"Parachute"
];